/*  basic.h -- general macro definitions for all programs  */

#ifndef BASIC_H
#define BASIC_H



/* general purpose definitions  */

#ifndef MAX
#define MAX(a, b) (((a)>(b))?(a):(b))
#endif

#ifndef MIN
#define MIN(a, b) (((a)>(b))?(b):(a))
#endif

#ifndef ABS
#define ABS(x) (((x)<0)?(-(x)):(x))
#endif

#ifndef ROUND
#define ROUND(a) ((int)((a)+0.5))
#endif

#ifndef PI
#define PI 3.1415926535897932385
#endif

#define ARCSEC_PER_RAD ((360 * 60 * 60) / (2.0 * PI))
#define METERS_PER_ARCSEC (1.0e7 / (90 * 60 * 60))

#define METERS_PER_FEET 0.3048


typedef struct { double u, v; } UV;



/*  transform structure and functions  */

typedef struct {
    double ua, ub, uc, ud;
    double va, vb, vc, vd;
} Transform;

Transform *createTransform(UV swS, UV nwS, UV neS, UV seS,
			    UV swT, UV nwT, UV neT, UV seT);

void transform(Transform *f, UV s, UV *t);

void utm2ll(int zone, UV utm, UV *ll);

#endif   /* BASIC_H */
