/*  dem.h -- structures and prototype for reading DEM files  */

/* Will Evans */

#include <stdio.h>
#include "basic.h"

#define MAXROWS 1201
#define MAXCOLS 1201

typedef struct {
    int rows, cols;

/* information from "A" record */
    char name[145];
    int level;
    int elevation_pattern;
    int reference_system;
    int zone;					/* always zero */
    double map_projection_parameter[15];	/* always zero */
    int ground_unit;
    int elevation_unit;
    int n_polygon;
    UV corner[4];
    double minElevation, maxElevation;
    double axis_angle;
    int accuracy;
    double resolution[3];
    double cellx, celly;

/* information from "B" records */
    int rowsInProfile[MAXCOLS], colsInProfile[MAXCOLS];
    UV firstUVInProfile[MAXCOLS];
    double firstElevationInProfile[MAXCOLS];
    double minElevationInProfile[MAXCOLS], maxElevationInProfile[MAXCOLS];
    unsigned short data[MAXCOLS][MAXROWS];

/* information from "C" record */
    int C2;
    int C2x, C2y, C2z;
    int C2sample_size;
    int C5;
    int C5x, C5y, C5z;
    int C5sample_size;
} Dem;

void readDEM(FILE *fp, Dem *dp);
