/*  dem2pgm.c -- convert DEM file to PGM file  */

#include <stdlib.h>
#include <stdio.h>
#include "dem.h"

main(int argc, char *argv[])
{
    int i, j;
    FILE *fp;
    Dem *dp;

    if (argc != 2) {
	fprintf(stderr, "Usage: %s filename\n", argv[0]);
	exit(1);
    }

    fp = fopen(argv[1], "r");
    if (fp == NULL) {
	fprintf(stderr, "Can't open %s for read\n", argv[1]);
	exit(1);
    }

    dp = malloc(sizeof(Dem));
    if (dp == NULL) {
	fprintf(stderr, "Not enough memory to hold DEM.\n");
	exit(1);
    }

    readDEM(fp, dp);

    fprintf(stderr, "%s\n", dp->name);
    fprintf(stderr, "Writing...\n");

    fprintf(stdout, "P2\n");
    fprintf(stdout, "# produced by dem2pgm\n");
    fprintf(stdout, "%d %d\n", dp->cols, dp->rows);
    fprintf(stdout, "%d\n", dp->maxElevation);
    for (i = dp->rows - 1; i >= 0; --i) {
	for(j = 0; j < dp->cols; ++j) {
	    fprintf(stdout, "%u ", dp->data[j][i]);
	}
	fprintf(stdout, "\n");
    }

    return 0;
}
