/*  dmops.h -- definitions and prototypes for DM operations  */

/*
 * This code is mean to be a simple interface for programs
 * that want to do simple manipulations of DM terrain files.
 */

#ifndef DMOPS_H
#define DMOPS_H

#include <stdio.h>
#include "basic.h"

typedef struct {
    int width, height;
    UV swUV, nwUV, neUV, seUV;
    UV swXY, nwXY, neXY, seXY;
    short *data;
} DMdata;

#define dmRef(dm, i, j) ((dm)->data[(int)(j)*(dm)->width + (int)(i)])

void dmReadHeader(FILE *in, DMdata *dm, int *shouldSwap);
DMdata *dmRead(FILE *);

void dmWriteHeader(FILE *out, int width, int height,
		    UV swUV, UV nwUV, UV neUV, UV seUV,
		    UV swXY, UV nwXY, UV neXY, UV seXY);
void dmWrite(FILE *, DMdata *);

#endif /* DMOPS_H */
