/*  ppmops.h -- definitions for operating on PPM files  */


#ifndef PPMOPS_H
#define PPMOPS_H

#include <stdio.h>
#include "basic.h"
#include "dmops.h"

typedef struct {
    int width, height;
    UV swUV, nwUV, neUV, seUV;
    UV swXY, nwXY, neXY, seXY;
    unsigned char *red, *green, *blue;
    Transform *ll2xy;
} PPMdata;


typedef struct {
    int width, height;
    int number_of_layers;
    unsigned char *red, *green, *blue;
} RGBdata;


#define PPMRED(ppm, x, y) (*((ppm)->red + (ppm)->width*(int)(y) + (int)(x)))
#define PPMGREEN(ppm, x, y) (*((ppm)->green + (ppm)->width*(int)(y) + (int)(x)))
#define PPMBLUE(ppm, x, y) (*((ppm)->blue + (ppm)->width*(int)(y) + (int)(x)))

#define RED(rgb, x, y) (*((rgb)->red + (rgb)->width*(int)(y) + (int)(x)))
#define GREEN(rgb, x, y) (*((rgb)->green + (rgb)->width*(int)(y) + (int)(x)))
#define BLUE(rgb, x, y) (*((rgb)->blue + (rgb)->width*(int)(y) + (int)(x)))


void ppmWriteHeader(FILE *out, int width, int height,
		    UV swUV, UV nwUV, UV neUV, UV seUV,
		    UV swXY, UV nwXY, UV neXY, UV seXY);

PPMdata *ppmRead(FILE *);

RGBdata *initRGB(DMdata *grid);
void mergeRGB(RGBdata *rgb, PPMdata *ppm);


#endif /* PPMOPS_H */
