/*  print.c -- print routines for debugging  */

/* by Will Evans 10/3/96 */

#include "topo.h"



static void printDFS(Hier *hp, TriIndex t, Coord2d p1, Coord2d p2, Coord2d p3)
{
    Coord2d mid;

    if (ONSURFACE(hp, t)) {
	printCoord(p1);
	printCoord(p2);
	printCoord(p3);
	printf("\n");
    } else {

	assert(!ISLEAF(hp, t));

	midpoint(p1, p2, mid);
	printDFS(hp, LCHILD(t), p3, p1, mid);
	printDFS(hp, RCHILD(t), p2, p3, mid);
    }
}



void printRTIN(Hier *hp)
{
    printDFS(hp, 1, se, nw, sw);
    printDFS(hp, 2, nw, se, ne);
}



void printTri(Coord2d p1, Coord2d p2, Coord2d p3)
{
    printf("(%d %d %d) (%d %d %d) (%d %d %d)\n",
		    p1[0], p1[1], dmRef(grid, p1[0], p1[1]),
		    p2[0], p2[1], dmRef(grid, p2[0], p2[1]),
		    p3[0], p3[1], dmRef(grid, p3[0], p3[1]));
}



void printCoord(Coord2d p)
{
    printf("(%d %d %d) ", p[0], p[1], dmRef(grid, p[0], p[1]));
}
