/*  protos.h -- function prototypes for TopoVista  */


/* color.c */
void initColors(void);

/* control.c */
void openCtlWin(void);
void keyfunc(unsigned char key, int x, int y);
void specfunc(int, int x, int y);

/* emit.c */
void emitSurface(Hier *hp, int type);

/* heap.c */
TriIndex heapExtractMax(void);
void heapEmpty(void);
void heapInsert(TriIndex t, int v);
int heapTopVal(void);

/* infov.c */
int inROD(Coord2d p1, Coord2d p2, Coord2d p3);
int triInFOV(TriIndex t);

/* main.c */
void shutdown(void);

/* neighbor.c */
TriIndex nbr1(Hier *hp, TriIndex t);
TriIndex nbr2(Hier *hp, TriIndex t);
TriIndex nbr3(Hier *hp, TriIndex t);

/* overhead.c */
void openOvhWin(void);

/* print.c */
void printRTIN(Hier *hp);
void printCoord(Coord2d p);

/* split.c */
void split(Hier *hp, TriIndex t);

/* surface.c */
void errSurface(Hier *hp);
void heapSurface(Hier *hp);
int heapBadness(Hier *hp, TriIndex t);

/* tri.c */
Hier *initHier(void);
void midpoint(Coord2d p1, Coord2d p2, Coord2d m);
void getVerts(TriIndex t, Coord2d p1, Coord2d p2, Coord2d p3);

/* view.c */
int zval(int x, int y);
void openPspWin(void);
void buildSurface(void);
void viewChanged(void);
