/*  topo.h -- master include file for TopoVista  */



/* configuration */

#define WIDTH_3D   600		/* size of 3-D (perspective) window */
#define HEIGHT_3D  400

#define HEIGHT_2D  256		/* height of 2-D (overhead) window */

#define EYE_HEIGHT 2.0		/* eye height above terrain */
#define REF_HEIGHT 0.0		/* reference height above terrain */

/* error calculations */
#define DILATION 1.174		/* how fast does importance of distance decay?*/

/* relief shading */
#define COLORATION 0.7		/* color importance (vs. shading) (0. to 1.) */
#define CONTRAST   4.0		/* contrast stretching factor for relief */

/*  sea level: if -SEA_LEVEL <= elevation <= SEA_LEVEL, color as ocean  */
#define SEA_LEVEL 1		/* sea level means -1 to 1m elevation */

/* minimum valid elevation, in meters */
#define MIN_LEVEL -500		/* minimum valid elevation */



/* standard includes */

#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "basic.h"		/* general-purpose support library */
#include "ppmops.h"		/* ppm structures and operations */
#include "dmops.h"		/* dm structures and operations */

#include "defns.h"		/* definitions */
#include "globals.h"		/* globals */
#include "protos.h"		/* prototypes */
